/*global define, CKEDITOR, setTimeout, document*/
/*jslint vars: true*/
define(['ep/ui/editor', 'testsuite/qunit', 'jquery', '$ready!'], function (ep, QUnit, $) {
    'use strict';
    QUnit.module("ckeditor/plugins/epplaceholder");

    function cke_test(instance, openselector, closeselector, setfunction, testfunction, after) {
        instance.setData('');
        $(openselector).trigger('click');
        setTimeout(function () {
            setfunction();
            setTimeout(function () {
                QUnit.equal($('.cke_panel_frame').is(':visible'), true, 'dropdown for placehoder is visible');
                $('.cke_panel_frame').contents().find('li:first a').trigger('click');
                instance.focus();
                $(closeselector).trigger('click');
                setTimeout(function () {
                    var data = instance.getData();
                    testfunction(data);
                    QUnit.start();
                    after();
                }, 200);
            }, 200);
        }, 500);
    }

    QUnit.asyncTest("check placeholder functionality", function () {
        ep('#uieditor_ckeditortestinstance').uiEditor({
            'name' : 'ckeditortestinstance',
            'toolbar': 'FullscreenEmailPreview',
            pluginOptions : {
                epalmostfullscreen: {toolbar : "FullscreenEmailPreview"},
                epplaceholder : {
                    placeholder: [{"description": "Order number", "code": "#Alias"}, {"description": "Order date", "code": "#CreationDate[date]"}]
                },
                showPreview: true
            }
        });

        setTimeout(function () {
            cke_test(CKEDITOR.instances.uieditor_ckeditortestinstance,
                '.cke_button__epalmostfullscreen_icon', '.cke_button__epalmostfullscreenclose_icon',
                function () {
                    $('.cke_combo__epplaceholder a').trigger('click');

                    QUnit.ok($('.cke_combo__epplaceholder').length === 1, 'dropdown for placeholder was found');
                },
                function (data) {
                    var expected = /#Alias/;

                    QUnit.ok(data.search(expected) !== -1, 'placeholder was inserted');
                    QUnit.ok($('.ep-cke-full:visible').length === 0, 'Fullscreen mode is not visible');
                },
                function () {
                    ep('#uieditor_ckeditortestinstance').uiEditor('destroy');
                });
        }, 1000);
    });
});