/*globals define*/

define([
    'testsuite/qunit',
    'jquery',
    'de_epages/shop/ui/userblogwidget',
    'testsuite/sinon',
    'testsuite/qunit-fixture!de_epages/shop/ui/userblogwidget-test',

    'testsuite/sinon/server',
    'testsuite/sinon/ie',
    '$ready!'
], function (QUnit, $, de_epages, sinon, fixture) {
    'use strict';

    QUnit.module("de_epages/shop/ui/userblogwidget", {
        setup: function () {
            fixture.init();
        },

        teardown: function () {
            fixture.destroy();
        }
    });

    QUnit.test("de_epages/shop/ui/userblogwidget", function () {

        var xmlResponse = $('#rssData').html(),
            sandbox = sinon.sandbox.create(),
            server = sandbox.useFakeServer(),
            entryLength;

        server.respondWith([
            200,
            {"Content-Type": "application/rss+xml"},
            xmlResponse
        ]);

        $('.ep-UserBlogWidget').shopUiUserBlogWidget({
            'url': 'http://blog.epages.com/de/feed/'
        });

        server.respond();

        QUnit.equal(
            $('.ep-shopUiUserBlogWidget-itemContent').length,
            3,
            'check entry count'
        );

        entryLength = de_epages('.ep-UserBlogWidget').shopUiUserBlogWidget('option', 'entryLength');

        $('.ep-shopUiUserBlogWidget-itemTitle').each(function () {

            QUnit.ok(this.innerHTML.length <= entryLength, "check entryLength");

        });

        QUnit.equal(
            $('.ep-uiTooltip').length,
            3,
            'check tooltip count'
        );
    });
});